module T where
open import Foreign.Haskell
open import IO.Primitive
open import Data.String as String using (String; toCostring)

open import Level using (Level; Lift) renaming 
                                 (zero to 0L; suc to sucL; _⊔_ to _⊔L_)
open import Data.Unit    using (⊤)
open import Data.Nat     using (ℕ; _>_) 
open import Data.List    using (List; []; _∷_; map)
open import Data.Product using (_×_) 

ManyProduct : {l l' : Level} {A : Set l} → (A → Set l') → List A → 
                                                          Set (l ⊔L l')
ManyProduct _ []       =  Lift ⊤
ManyProduct F (x ∷ xs) =  (F x) × (ManyProduct F xs)

f : (ns : List ℕ) -> ManyProduct (\ n → n > 0) ns -> ℕ
f _ _ = 0

main : IO Foreign.Haskell.Unit
main = putStrLn (toCostring "done")
